#include "version.h"
#include <unistd.h>
#include <stdio.h>
#include <strings.h>
#include <unistd.h>


#include "configfile.h"
#include "util.h"
#include "net.h"
#include "msignal.h"
#include "buf.h"
#include "object.h"
#include "char.h"
#include "char_data.h"
#include "item.h"
#include "readmap.h"
#include "function.h"
#include "saacproto_cli.h"
#include "lssproto_serv.h"
#include "readnpc.h"
#include "log.h"
#include "handletime.h"
#include "title.h"
#include "encount.h"
#include "enemy.h"
#include "battle.h"
#include "magic_base.h"
#include "pet_skill.h"
#include "item_gen.h"
#include "petmail.h"
#include "npc_quiz.h"


#ifdef _M_SERVER
#include "mclient.h"
#endif

#ifdef _NPCSERVER_NEW
#include "npcserver.h"
#endif

#ifdef _PROFESSION_SKILL			// WON ADD ְҵ
#include "profession_skill.h"
#endif

#ifdef _ITEM_QUITPARTY
#include "init.h"
//int itemquitparty_num = 0;
//static DisappearItem *Disappear_Item;
#endif

#define MESSAGEFILE "hoge.txt"

#define OPTIONSTRING "d:f:h"
#define usage() print( "Usage: %s ["OPTIONSTRING"]\n", getProgname() );

void printUsage( void )
{
    usage();
  /*print( "Usage: %s ["OPTIONSTRING"]\n", progname );*/
    print( "          [-d debuglevel]        default value is 0\n" );
    print( "          [-f configfilename]    default value is setup.cf\n"
        );
}

/*
 * Ѩ̼ë  
 *
 * ¦
 *      argc      ٯ  
 *      argv      ٯ      
 * ߯Ի
 *      TRUE(1)     ئѨ̼¦ѷ
 *      FALSE(0)    ئѨ̼¦ѷ
 */
BOOL parseCommandLine( int argc , char** argv )
{
    int c;                          /* getopt ƥ */
    extern char* optarg;            /* getopt ƥ */


    while( ( c = getopt( argc, argv ,OPTIONSTRING )) != -1 ){
        switch( c ){
        case 'd':
        {
            int     debuglevel;
            if( !strtolchecknum( optarg, (int*)&debuglevel, 10,
                                 INT)){
                print( "Specify digit number\n" );
                return FALSE;
            }
            setDebuglevel( debuglevel );
            break;
        }
        case 'f':
            setConfigfilename( optarg );
            break;
        case 'h':
            printUsage();
            return FALSE;
            break;

        default:
            printUsage();
            return FALSE;
            break;

        }
    }
    return TRUE;
}


/*
 *   ëɡ
 * ¦
 *      env       Ѽ    
 *
 * ἰئ
 */
BOOL parseEnvironment( char** env )
{
    if( getDebuglevel() >= 3 ){
        int index=0;
        while( env[index] != NULL )print( "%s " , env[index++] );
        print( "\n" );
    }
    return TRUE;
}




/*lsgenüƽ뼰  */
#define LSGENWORKINGBUFFER  65536*4



#define GOTORETURNFALSEIFFALSE(x) if(!(x))goto RETURNFALSE
/*
 * 
 * ¦
 *      argc    argv
 *      argv    Ѩ̼¦
 *      env       
 * ߯Ի
 *      TRUE(1)   
 *      FALSE(1)   
 */
BOOL init(int argc , char** argv , char** env )
{
#ifdef _ITEM_QUITPARTY
    FILE *f;
	int i;
	char line[256];
#endif
    srand( getpid());
    print( "This Program is compiled at %s %s by gcc %s\n",
           __DATE__ , __TIME__ , __VERSION__ );

    defaultConfig( argv[0] );
    signalset();

    GOTORETURNFALSEIFFALSE(parseCommandLine( argc , argv ));
    GOTORETURNFALSEIFFALSE(parseEnvironment( env ));

    {
        Char    aho;
        debug( sizeof( aho ), d);
        debug( sizeof( aho.data ), d);
        debug( sizeof( aho.string ), d);
        debug( sizeof( aho.flg ),d);
        debug( sizeof( aho.indexOfExistItems ), d);
        debug( sizeof( aho.haveSkill ), d);
        debug( sizeof( aho.indexOfHaveTitle ), d);
        debug( sizeof( aho.addressBook ),d);
        debug( sizeof( aho.workint ),d);
        debug( sizeof( aho.workchar ),d);
    }

    print( "ļ: %s\n" , getConfigfilename() );

    GOTORETURNFALSEIFFALSE(readconfigfile( getConfigfilename() ) );
    //ttom start
    {  int iWork = setEncodeKey();
       if( iWork == 0 ){
       // ޼ƽëɬ
       printf( "----------------------------------------\n" );
       printf( "-------------[] ޷ %s\n", getConfigfilename() );
       printf( "----------------------------------------\n" );
       exit( 1 );
       }else{
            // ޼ƽëɬ
               printf( " = %d\n", iWork );
       }
    }
    // AcWBuffëɬ
    {   int iWork = setAcWBSize();
        if( iWork == 0 ){
           printf( "----------------------------------------\n" );
           printf( "-------------[AC] ޷ %s\n", getConfigfilename() );
           printf( "----------------------------------------\n" );
           exit( 1 );
           }else{
                   printf( "AC = %d\n", iWork );
           }
    }
    //ttom end

    if( getDebuglevel() >= 1 ){
//		print("ServerType: %d\n", getServerType() );
        print("Եȼ: %d\n" , getDebuglevel() );
        print("ڴ浥Ԫ: %d\n"  , getMemoryunit() );
        print("ڴ浥Ԫ: %d\n" , getMemoryunitnum() );

        print("˺ŷַ: %s\n" , getAccountservername() );
        print("˺ŷ˿: %d\n" , getAccountserverport() );
        print("½: %s\n",
              getGameservername());
        print("½: %s\n", getAccountserverpasswd());

        print("ȴӶ˿: %d\n",  getPortnumber() );

        print("к: %d\n",  getServernumber() );

        print("ظַʹ: %d\n",  getReuseaddr() );


        print(": %d\n",
              getFdnum() );
        print("߳: %d\n" , getPetcharnum() );
        print("Ŀ: %d\n"  , getOtherscharnum() );
        print("Ŀ: %d\n",  getObjnum() );
        print("ƷĿ: %d\n",  getItemnum() );
        print("սĿ: %d\n",  getBattlenum() );
#ifdef _GET_BATTLE_EXP
				print("ս鱶: %d\n",  getBattleexp() );
#endif
        print("ļĿ¼: %s\n"  , getTopdir());
        print("ͼļĿ¼: %s\n"  , getMapdir());
        print("ͼʶļ: %s\n"  , getMaptilefile());
        print("Ʒļ: %s\n"  , getItemfile());
        print("սļ: %s\n"  , getInvfile());
        print("ʾλļ: %s\n"  , getAppearfile());
        print("ļ: %s\n"  , getEffectfile());
        print("ͷļ: %s\n"  , getTitleNamefile());
        print("ͷļ: %s\n"  , getTitleConfigfile());
        print("ļ: %s\n"  , getEncountfile());
        print("Ⱥļ: %s\n"  , getGroupfile());
        print("ļ: %s\n"  , getEnemyBasefile());
        print("ļ: %s\n"  , getEnemyfile());
        print("ħļ: %s\n"  , getMagicfile());

#ifdef __ATTACK_MAGIC
        print("ħļ: %s\n" , getAttMagicfileName() );
#endif

        print("＼ļ: %s\n"  , getPetskillfile());

#ifdef _PROFESSION_SKILL			// WON ADD ְҵ
        print("ְҵļ: %s\n"  , getProfession());
#endif

        print("Ʒɷļ: %s\n", getItematomfile());
        print("ļ: %s\n", getQuizfile());
#ifdef _BLACK_MARKET
				print("гļ: %s\n", getBMItemFile());
#endif
#ifdef _GMRELOAD
				print("G M ļ: %s\n", getGMSetfile());
#endif
        print("־¼ļ: %s\n"  ,  getLsgenlogfilename() );
        print("ԭĿ¼: %s\n"  , getStoredir());
        print("NPC Ŀ¼: %s\n"  , getNpcdir());
        print("־ļ: %s\n",  getLogdir());
        print("־ļ: %s\n", getLogconffile() );
        print("GMָ: %s\n", getChatMagicPasswd() );
        print("ʹGMȨ: %d\n", getChatMagicCDKeyCheck() );

        print("NPC ģĿ: %d\n"  , getNpctemplatenum() );
        print("NPC Ŀ: %d\n"  , getNpccreatenum() );

        print("·ʱ: %d\n"  , getWalksendinterval());
        print("м: %d\n"  , getCAsendinterval_ms());
        print("Ŀ: %d\n"  , getCDsendinterval_ms());
        print("ִһʱ: %d\n"  , getOnelooptime_ms());
        print("ʱ: %d\n"  , getPetdeletetime());
        print("ʱ: %d\n"  , getItemdeletetime());
#ifdef _DEL_DROP_GOLD
				print("ʯʱ: %d\n"  , getGolddeletetime());
#endif
        print("ݱ: %d\n"  , getCharSavesendinterval());

        print("ƬĿ: %d\n",getAddressbookoffmsgnum());
        print("ȡƵЭ: %d\n",getProtocolreadfrequency());

        print("Ӵ: %d\n",getAllowerrornum());

#ifdef	_M_SERVER
		    print("GMַ: %s\n",getmservername());
		    print("GM˿: %d\n",getmserverport());
#endif
#ifdef _NPCSERVER_NEW
				print("Npcַ: %s\n",getnpcserveraddr());
				print("Npc˿: %d\n",getnpcserverport());
#endif
#ifdef _NEW_PLAYER_CF
				print("ת: %d\n",getNewplayertrans());
				print("ȼ: %d\n",getNewplayerlv());
				print("Ǯ: %d\n",getNewplayergivegold());
				print("ȼ: %d\n",getNewplayerpetlv());
				print("ӵг: NO1:%d NO2:%d NO3:%d NO4:%d NO5:%d\n",getNewplayergivepet(0),
																																	getNewplayergivepet(1),
																																	getNewplayergivepet(2),
																																	getNewplayergivepet(3),
																																	getNewplayergivepet(4));
				print("ӵƷ: ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
							"ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
							"ITEM1:%d ITEM2:%d ITEM3:%d ITEM4:%d ITEM5:%d\n"
																																	,getNewplayergiveitem(0)
																																	,getNewplayergiveitem(1)
																																	,getNewplayergiveitem(2)
																																	,getNewplayergiveitem(3)
																																	,getNewplayergiveitem(4)
																																	,getNewplayergiveitem(5)
																																	,getNewplayergiveitem(6)
																																	,getNewplayergiveitem(7)
																																	,getNewplayergiveitem(8)
																																	,getNewplayergiveitem(9)
																																	,getNewplayergiveitem(10)
																																	,getNewplayergiveitem(11)
																																	,getNewplayergiveitem(12)
																																	,getNewplayergiveitem(13)
																																	,getNewplayergiveitem(14));
#endif
#ifdef _UNLAW_WARP_FLOOR
		print("ֹ͵ͼ: FLOOR1:%d FLOOR2:%d FLOOR3:%d FLOOR4:%d FLOOR5:%d\n",getUnlawwarpfloor(0),
																																	getUnlawwarpfloor(1),
																																	getUnlawwarpfloor(2),
																																	getUnlawwarpfloor(3),
																																	getUnlawwarpfloor(4));
#endif
#ifdef _UNREG_NEMA
		print("ֹ: NAME1:%s NAME2:%s NAME3:%s NAME4:%s NAME5:%s\n",getUnregname(0),
																																	getUnregname(1),
																																	getUnregname(2),
																																	getUnregname(3),
																																	getUnregname(4));
#endif
#ifdef _TRANS_LEVEL_CF
		print("ȼת: %d\n",getChartrans());
		print("ȼת: %d\n",getPettrans());
#endif

#ifdef _LOCK_IP
		print(" IP : %s\n",getLockipPath());
#endif
    }

	{	//andy_add 2003/05/05 check GameServer Name
		char *GameServerName;
		GameServerName = getGameserverID();
		if( GameServerName == NULL || strlen( GameServerName) <= 0 )
			return FALSE;
		print("\nϷID: %s\n",  GameServerName );
	}
	
    print("ʼʼ\n" );

//#define DEBUG1( arg... ) if( getDebuglevel()>1 ){##arg}
    print( "ڴռ..." );
    GOTORETURNFALSEIFFALSE(configmem( getMemoryunit(),
                                      getMemoryunitnum() ) );
    GOTORETURNFALSEIFFALSE(memInit());
	print( "\n" );
    if( !initConnect(getFdnum()) )
        goto MEMEND;
    while( 1 ){
        print( "԰󶨱ض˿ %d... " , getPortnumber());
        bindedfd = bindlocalhost( getPortnumber() );
        if( bindedfd == -1 )
            sleep( 10 );
        else
            break;

    }
	print( "\n" );
	print( "..." );
    if( !initObjectArray( getObjnum()) )
        goto CLOSEBIND;
	print( "\n" );
	print( "..." );
    if(!CHAR_initCharArray( getFdnum(), getPetcharnum(),getOtherscharnum()) )
        goto CLOSEBIND;
	print( "\n" );
	print( "Ʒ:%s...", getItemfile());
    if(!ITEM_readItemConfFile( getItemfile()) )
        goto CLOSEBIND;
    if(!ITEM_initExistItemsArray( getItemnum() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ս..." );
    if(!BATTLE_initBattleArray( getBattlenum() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ģ..." );
    if( !initFunctionTable() )
        goto CLOSEBIND;
	print( "\n" );

	print( "ʼʼ..." );
    if( !PETMAIL_initOffmsgBuffer( getAddressbookoffmsgnum() ))
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡսļ..." );
    if( !CHAR_initInvinciblePlace( getInvfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡʾλļ..." );
    if( !CHAR_initAppearPosition( getAppearfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡͷļ..." );
    if( !TITLE_initTitleName( getTitleNamefile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡͷļ..." );
    if( !TITLE_initTitleConfig( getTitleConfigfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡļ..." );
    if( !ENCOUNT_initEncount( getEncountfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡļ..." );
    if( !ENEMYTEMP_initEnemy( getEnemyBasefile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡļ..." );
    if( !ENEMY_initEnemy( getEnemyfile() ) )
        goto CLOSEBIND;
	print( "\n" );

	print( "ȡȺļ..." );
    if( !GROUP_initGroup( getGroupfile() ) )
        goto CLOSEBIND;
	print( "\n" );
	print( "ȡħļ..." );
    if( !MAGIC_initMagic( getMagicfile() ) )
        goto CLOSEBIND;
	print( "\n" );

		#ifdef __ATTACK_MAGIC

	print( "ȡħļ..." );

    if( !ATTMAGIC_initMagic( getAttMagicfileName() ) )
//		if( !ATTMAGIC_initMagic( getMagicfile() ) )
        goto CLOSEBIND;

	print( "ħļ -->%s..." , getAttMagicfileName());
	print( "\n" );

    #endif
 
	print( "ȡ＼ļ..." );
    if( !PETSKILL_initPetskill( getPetskillfile() ) )
        goto CLOSEBIND;
	print( "\n" );

#ifdef _PROFESSION_SKILL			// WON ADD ְҵ
	print( "ȡְҵļ..." );
	if( !PROFESSION_initSkill( getProfession() ) ){
		goto CLOSEBIND;
	}
	print( "\n" );
#endif

    /* ʧ  ة    ë   */
	print( "ȡƷɷļ..." );
    if( !ITEM_initItemAtom( getItematomfile()) )
        goto CLOSEBIND;
	print("\n" );

	print( "ʼƷٻ..." );
    if( !ITEM_initItemIngCache() )
        goto CLOSEBIND;
	print("\n" );
    
	print( "ʼƷ..." );
    if( !ITEM_initRandTable() )
        goto CLOSEBIND;
	print("\n" );
    
	print( "ȡļ..." );
    if( !CHAR_initEffectSetting( getEffectfile() ) )
        goto CLOSEBIND;
	print( "\n" );
	print( "ȡļ..." );
    if( !QUIZ_initQuiz( getQuizfile() ) )
        goto CLOSEBIND;
	print( "\n" );

#ifdef _BLACK_MARKET
	print( "гļ..." );
	if ( !LoadBMItem(getBMItemFile()) )
		goto CLOSEBIND;
	print( "\n" );
#endif

#ifdef _GMRELOAD
	print( "ȡGMļ..." );
	if ( !LoadGMSet( getGMSetfile() ) )
		goto CLOSEBIND;
	print( "\n" );
#endif

#ifdef _GMRELOAD
	print( "ȡļ..." );
	if ( !LoadEXP( getEXPfile() ) )
		goto CLOSEBIND;
	print("ߵȼ: %d...",getMaxLevel());
	print("һȼ: %d...",getYBLevel());
	print( "\n" );
#endif

#ifdef _ANGEL_SUMMON
	print("ȡбļ...");
	if( !LoadMissionList( ) )
		goto CLOSEBIND;
	print("\n");
#endif

#ifdef _CONTRACT
	print("ȡԼļ...");
	//if( !LoadMissionList( ) )
	//	goto CLOSEBIND;
	if( !ITEM_initContractTable() )
		goto CLOSEBIND;
	print("\n");
#endif

#ifdef _JOBDAILY
	print("ȡ־ļ...");
	if(!LoadJobdailyfile())
		goto CLOSEBIND;
	print("\n");
#endif

#ifdef _RACEMAN
	print("ȡļ...");
	if(!LoadRacepetfile())
		goto CLOSEBIND;
	print("\n");
#endif

#ifdef _LOCK_IP
	print("ȡIPļ...");
	if(!loadLockip( getLockipPath()))
		goto CLOSEBIND;
	print("\n");
#endif

	print( "ͼ..." );
    if( !MAP_initReadMap( getMaptilefile() , getMapdir() ))
        goto CLOSEBIND;
	print( "\n" );
	print( "ȡNPCļ..." );
    if( !NPC_readNPCSettingFiles( getNpcdir(), getNpctemplatenum(),
                                  getNpccreatenum() ) )
        goto CLOSEBIND;
	print( "\n" );
	print( "ʼ NPC ... " );
    if( lssproto_InitServer( lsrpcClientWriteFunc, LSGENWORKINGBUFFER ) < 0 )
        goto CLOSEBIND;
	print( "\n" );
	print( "˺ŷ... " );
    acfd = connectHost( getAccountservername(), getAccountserverport());
    if(acfd == -1)
        goto CLOSEBIND;

/*
	{
		int errorcode;
		int errorcodelen;
		int qs;

		errorcodelen = sizeof(errorcode);
		qs = getsockopt( acfd, SOL_SOCKET, SO_RCVBUF , &errorcode, &errorcodelen);
		//andy_log
		print("\n\n GETSOCKOPT SO_RCVBUF: [ %d, %d, %d] \n", qs, errorcode, errorcodelen);
	}
*/

	print( "\n" );
    initConnectOne( acfd, NULL , 0 );
    if( !CONNECT_acfdInitRB( acfd)) goto CLOSEAC;
    if( !CONNECT_acfdInitWB( acfd)) goto CLOSEAC;
    CONNECT_setCtype( acfd, AC );
	
	print( "ʼ NPC ͻ ... " );
    /*  rpc(client) */
    if( saacproto_InitClient( lsrpcClientWriteFunc,LSGENWORKINGBUFFER, acfd) < 0 )
        goto CLOSEAC;
	print( "\n" );

	print( "˺ŷ͵½... " );
    /*  ̼ۢë  */
    saacproto_ACServerLogin_send(acfd, getGameservername(),
                                 getAccountserverpasswd());
	print( "\n" );

    if( isExistFile( getLsgenlogfilename() ) ){
        lssproto_SetServerLogFiles( getLsgenlogfilename(),
                                    getLsgenlogfilename() );
        saacproto_SetClientLogFiles( getLsgenlogfilename(),
                                     getLsgenlogfilename() );
    }


	print( "ʼ\n" );

#ifdef _MUSEUM
	if( getMuseum() )
		print("\nʯ!!\n");
	else
		print("\nͨ!!\n");
#endif

	print( "ʼʼ־\n" );
    {
        char    logconffile[512];
        snprintf( logconffile, sizeof( logconffile), "%s/%s" ,
                  getLogdir(), getLogconffile() );
        if( !initLog( logconffile ) )
            goto CLOSEAC;
    }

#ifdef _M_SERVER
	print( "GM... " );
    mfd = connectmServer( getmservername(), getmserverport());
	if (mfd ==-1 ){
		print( "GMʧ... " );
	}else{
		initConnectOne( mfd, NULL , 0 );
		print( "ɰGM... " );
	}
#endif

#ifdef _NPCSERVER_NEW
	npcfd = connectNpcServer( getnpcserveraddr(), getnpcserverport());
	if( npcfd == -1 ){
		print( "NPCʧ... " );
	}else{
		initConnectOne( npcfd, NULL , 0 );
		print( "ɰNPC... " );
		NPCS_NpcSLogin_send( npcfd);
	}
#endif
	
#ifdef _ITEM_QUITPARTY
	print( "ȡɢƷʧļ..." );
    
	//ȡ
    f = fopen( getitemquitparty(), "r" );
	if( f != NULL ){
		while( fgets( line, sizeof( line ), f ) ){
			if( line[0] == '#' )continue;
            if( line[0] == '\n' )continue;
		    chomp( line );
			itemquitparty_num++;
		}
		if( fseek( f, 0, SEEK_SET ) == -1 ){
			print( "Ʒ¼Ҵ\n" );
			fclose(f);
			goto CLOSEAC;
		}
		//
		Disappear_Item = allocateMemory( sizeof(struct tagDisappearItem) * itemquitparty_num );
		if( Disappear_Item == NULL ){
			print( "޷ڴ %d\n", sizeof(struct tagDisappearItem) * itemquitparty_num );
			fclose( f );
			goto CLOSEAC;
		}

		i = 0;
		//߱Ŵ Disappear_Item.string
		while( fgets( line, sizeof( line ), f ) ){
			if( line[0] == '#' )continue;
			if( line[0] == '\n' )continue; 
			chomp( line );
			sprintf( Disappear_Item[i].string,"%s",line );
			print("\n߱:%s", Disappear_Item[i].string );
			i++;
		}
		fclose(f);
	}
#endif

    DEBUG_ADJUSTTIME = 0;
    print( "\n" );
    return TRUE;

CLOSEAC:
    close( acfd );
CLOSEBIND:
    close( bindedfd );
    endConnect();
MEMEND:
    memEnd();
RETURNFALSE:
    return FALSE;
}
